package net.wanji.utc.cache;

import net.wanji.common.enums.BaseEnum;
import net.wanji.common.framework.spring.ServiceBeanContext;
import net.wanji.feign.service.common.UtcFeignCommon;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @author duanruiming
 * @date 2023/05/22 10:20
 */
@Component
public class UtcFeignClientCache implements CommandLineRunner {

    public static final Map<String, UtcFeignCommon> utcFeignClientsMap = new HashMap<>();

    public UtcFeignCommon getUtcFeignClientService(String name) {
        if (!utcFeignClientsMap.isEmpty()) {
            return utcFeignClientsMap.get(name);
        }
        return null;
     }
    @Override
    public void run(String... args) throws Exception {
        init();
    }

    public void init() {
        Map<String, UtcFeignCommon> interfaceBeanMap = ServiceBeanContext.getInterfaceBeanMap(UtcFeignCommon.class);
        if (!interfaceBeanMap.isEmpty()) {
            for (Map.Entry<String, UtcFeignCommon> item : interfaceBeanMap.entrySet()) {
                String feignName = item.getKey();
                UtcFeignCommon utcFeignClientService = item.getValue();
                for (BaseEnum.VendorTypeEnum value : BaseEnum.VendorTypeEnum.values()) {
                    if (feignName.contains(value.getNick())) {
                        utcFeignClientsMap.put(value.getNick(), utcFeignClientService);
                        break;
                    }
                }
            }
        }
    }
}
